-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4520 of the CMF schema.
-- Add cluster host association.
--

update SCHEMA_VERSION set VERSION=4520;

-- Add CLUSTER_ID columns to HOSTS
alter table HOSTS 
  add column CLUSTER_ID int8,
  add constraint FK_HOST_CLUSTER
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);
  
create index IDX_HOST_CLUSTER on HOSTS (CLUSTER_ID);

-- Make hosts belong to the right cluster based on its roles and services. Mgmt
-- roles are ignored by joining SERVICES with CLUSTERS.
update HOSTS 
  set CLUSTER_ID=(
    select distinct c.CLUSTER_ID from ROLES r 
      join ROLE_CONFIG_GROUPS rcg on r.ROLE_CONFIG_GROUP_ID = rcg.ROLE_CONFIG_GROUP_ID 
      join CONFIG_REVISIONS cr on rcg.REVISION_ID = cr.REVISION_ID 
      join SERVICES s on cr.SERVICE_ID = s.SERVICE_ID 
      join CLUSTERS c on s.CLUSTER_ID = c.CLUSTER_ID 
      where HOSTS.HOST_ID = r.HOST_ID
  );
